package com.brilliance.eibs.server;

import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.el.ApacheEL;
import com.brilliance.eibs.main.JmsHandle;
import com.tibco.tibjms.TibjmsQueueConnectionFactory;

import javax.jms.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class TibcoJmsServer extends AbsServer

{

	private QueueReceiver receiver;
	private ExecutorService executorService;

	public TibcoJmsServer(Context context, IServiceDef serviceDef, ApacheEL elParser) {
		super(context, serviceDef, elParser);
	}

	@Override
	public void run() {
		String serverUrl = getRequiredPropertyValue(SERVER_URL);
		String userName = getRequiredPropertyValue(USER_NAME);
		String password = getPropertyValue(PASSWORD);
		String queuename = getRequiredPropertyValue(QUEUE);
		String interfaceName = getRequiredPropertyValue("interfaceName");
		String transName = getRequiredPropertyValue("transactionName");

		int size = Integer.valueOf(getRequiredPropertyValue(THREAD_POOL_SIZE_SYMBOL));
		executorService = Executors.newFixedThreadPool(size);
		try {

			TibjmsQueueConnectionFactory factory = new TibjmsQueueConnectionFactory(serverUrl);
			QueueConnection connection = factory.createQueueConnection(userName, password);
			// QueueConnection connection2 = factory.createQueueConnection(
			// userName, password);
			QueueSession session = connection.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
			// QueueSession session2 = connection.createQueueSession(false,
			// Session.AUTO_ACKNOWLEDGE);
			Queue queue = session.createQueue(queuename);
			// Queue queue2 = session2.createQueue(queuename);
			receiver = session.createReceiver(queue);
			// QueueReceiver receiver2 = session.createReceiver(queue2);
			connection.start();
			// connection2.start();
			while (true) {
				Message msgMessage = receiver.receive();

				if (msgMessage instanceof TextMessage) {
					try {
						String str = ((TextMessage) msgMessage).getText();
						executorService.submit(new JmsHandle(interfaceName, transName, str));
						// new Thread(new JmsHandle(interfaceName, transName,
						// str)).start();
					} catch (JMSException e) {
						receiver.close();
					}

				}
			}
		} catch (Exception e) {
		} finally {
			close();
		}

	}

	@Override
	public void close() {
		if (null != receiver)
			try {
				receiver.close();
			} catch (JMSException e) {
			}
		if (null != executorService)
			executorService.shutdown();
	}

}
