package com.brilliance.eibs.server;

import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.el.ApacheEL;
import com.brilliance.eibs.main.UdpHandle;

import java.net.DatagramPacket;
import java.net.DatagramSocket;

/**
 * udpserver
 * 
 * @author gechengyang
 *
 */
public class UdpServer extends AbsServer {
	private boolean isOpen = true;

	public UdpServer(Context context, IServiceDef serviceDef, ApacheEL elParser) {
		super(context, serviceDef, elParser);
	}

	@Override
	public void run() {
		logger.info( LOG_FLAG + "UdpServer starting ." + LOG_FLAG);
		try {
			// 服务发布的端口
			int port = Integer.valueOf(getRequiredPropertyValue(PORT_SYMBOL));
			int buffersize = Integer.valueOf(getRequiredPropertyValue(BUFFER_SIZE));
			logger.info( "socketserver port=" + port);
			String interfaceName = getRequiredPropertyValue("interfaceName");
			String transName = getRequiredPropertyValue("transactionName");
			DatagramSocket server = new DatagramSocket(port);

			logger.info( "server start at port: " + port);
			while (isOpen) {
				DatagramPacket dataPacket = null;
				byte buffer[] = new byte[buffersize];
				dataPacket = new DatagramPacket(buffer, buffer.length);
				server.receive(dataPacket);
				String revs = new String(buffer, 0, dataPacket.getLength());
				logger.info( "dataPackegt.length=" + dataPacket.getLength());
				logger.info( "server recive:" + revs);
				byte[] b = new byte[dataPacket.getLength()];
				System.arraycopy(buffer, 0, b, 0, dataPacket.getLength());
				// new Thread(new UdpHandle(interfaceName, transName, revs,
				// dataPacket, server)).start();
				new Thread(new UdpHandle(interfaceName, transName, b, dataPacket, server)).start();
				// byte[] sndinfo = "1234567".getBytes();
				// DatagramPacket dataPacket1 = new DatagramPacket(sndinfo,
				// sndinfo.length, dataPacket.getAddress(),
				// dataPacket.getPort());

				// server.send(dataPacket1);
				// server.close();
			}
			close();
		} catch (Exception e) {

			throw new InterfaceException("03001", e);
		} finally {

		}
		logger.info( LOG_FLAG + "UdpServer is finished." + LOG_FLAG);
	}

	@Override
	public void close() {

	}

}
